/*----------------------------------------------------------------------*/
/*								    									*/
/*----------------------------------------------------------------------*/
#include	"sgl.h"
#include	"sega_sys.h"
#include	"backff22.cel"
#include	"backff22.map"
#include	"backff22.pal"

#define		NBG1_CEL_ADR		( VDP2_VRAM_B1 + 0x02000 )
#define		NBG1_MAP_ADR		( VDP2_VRAM_B1 + 0x12000 )
#define		NBG1_COL_ADR		( VDP2_COLRAM + 0x00200 )
#define		BACK_COL_ADR		( VDP2_VRAM_A1 + 0x1fffe )
#define		PAD_NUM			13

static Uint16 pad_asign[] = {
	PER_DGT_KU,
	PER_DGT_KD,
	PER_DGT_KR,
	PER_DGT_KL,
	PER_DGT_TA,
	PER_DGT_TB,
	PER_DGT_TC,
	PER_DGT_ST,
	PER_DGT_TX,
	PER_DGT_TY,
	PER_DGT_TZ,
	PER_DGT_TR,
	PER_DGT_TL,
};

extern TEXTURE tex_spr[];
extern PICTURE pic_spr[];
extern FIXED stat[][XYZS];
extern SPR_ATTR attr[];
extern ANGLE angz[];

int walk, walkb, stand;

/*----------------------------------------------------------------------*/
static void set_sprite(PICTURE *pcptr , Uint32 NbPicture)
{
	TEXTURE *txptr;
 
	for(; NbPicture-- > 0; pcptr++){
		txptr = tex_spr + pcptr->texno;
		slDMACopy((void *)pcptr->pcsrc,
			(void *)(SpriteVRAM + ((txptr->CGadr) << 3)),
			(Uint32)((txptr->Hsize * txptr->Vsize * 4) >> (pcptr->cmode)));
	}
}

/*----------------------------------------------------------------------*/
static void disp_sprite(int SpriteNo)
{
	
	slDispSprite((FIXED *)stat[SpriteNo], (SPR_ATTR *)(&attr[SpriteNo].texno), DEGtoANG(0));
	
}

/*----------------------------------------------------------------------*/
void ss_main(void)
{
	Uint16 data;
	Sint32 posX, posY, BGposX, BGposY, tempo;
	
	PerDigital	*pptr ;
    Sint16	padp ;

	int punch;

	slInitSystem(TV_320x224,tex_spr,1);
	slTVOff();
	set_sprite(pic_spr,25);

	slColRAMMode(CRM16_1024);
	slBack1ColSet((void *)BACK_COL_ADR , 0);

	slCharNbg1(COL_TYPE_256 , CHAR_SIZE_1x1);
	slPageNbg1((void *)NBG1_CEL_ADR , 0 , PNB_1WORD|CN_12BIT);
	slPlaneNbg1(PL_SIZE_1x1);
	slMapNbg1((void *)NBG1_MAP_ADR , (void *)NBG1_MAP_ADR , (void *)NBG1_MAP_ADR , (void *)NBG1_MAP_ADR);
	
	Cel2VRAM(backff22_cel , (void *)NBG1_CEL_ADR , 1171*64);   
	Map2VRAM(backff22_map , (void *)NBG1_MAP_ADR , 40 , 32 , 1 , 256);
	Pal2CRAM(backff22_pal , (void *)NBG1_COL_ADR , 86);
	
	slScrPosNbg1(toFIXED(0.0) , toFIXED(0.0));
	//slScrAutoDisp(NBG0ON | NBG1ON);
	slScrAutoDisp(NBG1ON);
	
	slTVOn();

	posX = 0;
	posY = 0;
	walk = 0;
	walkb = 0;
	punch = 0;
	tempo = 0;
	

	while(1) 
	{
		if(!Per_Connect1) return;
		data = Smpc_Peripheral[0].data;
		
		pptr = Smpc_Peripheral;
		padp = ~pptr->push;

		if((data & pad_asign[5])==0)			/* si appuie sur B */
		{
			//ss_main();
			BGposX += toFIXED(1.0);
		}	
		if((data & pad_asign[6])==0)			/* si appuie sur C */
		{
			BGposX -= toFIXED(1.0);
		}	
		
		if(((data & pad_asign[0])==0) & (punch==0) )		/* si appuie en haut */
		{			
			walk += toFIXED(1.0);
			stat[0][1] -= toFIXED(2.0);	
			if(stat[0][1] <= 0)
			{
				stat[0][1]=0;
			}
			UpdateSpritePosition();
			RockWalkForward();
		}
		
		if(((data & pad_asign[1])==0) & (punch==0) )		/* si appuie en bas */
		{			
			walk += toFIXED(1.0);
			stat[0][1] += toFIXED(2.0);
			if(stat[0][1] >= toFIXED(50.0))
			{
				stat[0][1]=toFIXED(50.0);
			}
			UpdateSpritePosition();
			RockWalkForward();
		}

		if(((data & pad_asign[2])==0) & (punch==0) )		/* si appuie a droite */
		{
			walk += toFIXED(1.0);
			stat[0][0] += toFIXED(2.0);
			
			UpdateSpritePosition();
			RockWalkForward();
			
		}
		//stand
		if(((data & pad_asign[0])!=0) & ((data & pad_asign[1])!=0) & ((data & pad_asign[2])!=0) & ((data & pad_asign[3])!=0) & (punch==0) )
		{
			stand += toFIXED(1.0);
			RockStand();
		}

		
		if(((data & pad_asign[3])==0) & (punch==0) )		/* si appuie a gauche */
		{
			walk += toFIXED(1.0);
			stat[0][0] -= toFIXED(2.0);
			
			UpdateSpritePosition();
			//RockWalkBackward();	
			RockWalkForward();
		}

		
		if((padp & pad_asign[4]) )	/* si appuie sur A */
		{
			if(punch==0)
			{
				//tempo += toFIXED(1.0);
				punch = toFIXED(1.0);
			}
		}
		
		if(punch==toFIXED(1.0))
		//while(punch==toFIXED(1.0))
		{
			tempo += toFIXED(1.0);
			if(tempo <= toFIXED(3.0))
			{
				disp_sprite(7);
			}
			if(tempo <= toFIXED(7.0) & tempo >= toFIXED(4.0))
			{
				disp_sprite(8);
			}
			if(tempo <= toFIXED(11.0) & tempo >= toFIXED(8.0))
			{
				disp_sprite(9);
			}
			if(tempo <= toFIXED(16.0) & tempo >= toFIXED(12.0))
			{
				disp_sprite(10);
			}
			if(tempo == toFIXED(16))
			{
				punch = 0;
				tempo = 0;
			}
		}

		
		slPrintFX(stat[0][0], slLocate(25,20));
		slPrintFX(stat[0][1], slLocate(25,22));
		//slPrintFX(stat[5][1]-toFIXED(10.0), slLocate(25,24));
		//slPrintFX(stat[5][1]+toFIXED(10.0), slLocate(25,26));
		
	
		

		//  Mouvement du scrolling
		slScrPosNbg1(BGposX , BGposY);
		//BGposX += toFIXED(3.0);

		slSynch();
	} 
}

/*----------------------------------------------------------------------*/
void RockStand()
{
	if(stand <= toFIXED(3.0))
	{
		disp_sprite(11);
	}
	if(stand <= toFIXED(7.0) & stand >= toFIXED(4.0))
	{
		disp_sprite(12);
	}
	if(stand <= toFIXED(11.0) & stand >= toFIXED(8.0))
	{
		disp_sprite(13);
	}
	if(stand <= toFIXED(16.0) & stand >= toFIXED(12.0))
	{
		disp_sprite(14);
	}
	if(stand <= toFIXED(21.0) & stand >= toFIXED(17.0))
	{
		disp_sprite(15);
	}
	if(stand <= toFIXED(25.0) & stand >= toFIXED(22.0))
	{
		disp_sprite(16);
	}
	if(stand <= toFIXED(29.0) & stand >= toFIXED(26.0))
	{
		disp_sprite(17);
	}
	if(stand <= toFIXED(33.0) & stand >= toFIXED(30.0))
	{
		disp_sprite(18);
	}
	if(stand <= toFIXED(37.0) & stand >= toFIXED(34.0))
	{
		disp_sprite(19);
	}	
	if(stand == toFIXED(37))
	{
		stand = 0;
	}
}

/*----------------------------------------------------------------------*/
void RockWalkForward()
{
	if(walk <= toFIXED(3.0))
	{
		disp_sprite(0);
	}
	if(walk <= toFIXED(7.0) & walk >= toFIXED(4.0))
	{
		disp_sprite(1);
	}
	if(walk <= toFIXED(11.0) & walk >= toFIXED(8.0))
	{
		disp_sprite(2);
	}
	if(walk <= toFIXED(16.0) & walk >= toFIXED(12.0))
	{
		disp_sprite(3);
	}
	if(walk <= toFIXED(21.0) & walk >= toFIXED(17.0))
	{
		disp_sprite(4);
	}
	if(walk <= toFIXED(25.0) & walk >= toFIXED(22.0))
	{
		disp_sprite(5);
	}
	if(walk <= toFIXED(29.0) & walk >= toFIXED(26.0))
	{
		disp_sprite(6);
	}
	if(walk == toFIXED(29))
	{
		walk = 0;
	}
}

/*----------------------------------------------------------------------*/
RockWalkBackward()
{
	if(walkb <= toFIXED(3.0))
	{
		disp_sprite(20);
	}
	if(walkb <= toFIXED(7.0) & walkb >= toFIXED(4.0))
	{
		disp_sprite(21);
	}
	if(walkb <= toFIXED(11.0) & walkb >= toFIXED(8.0))
	{
		disp_sprite(22);
	}
	if(walkb <= toFIXED(16.0) & walkb >= toFIXED(12.0))
	{
		disp_sprite(23);
	}
	if(walkb <= toFIXED(21.0) & walkb >= toFIXED(17.0))
	{
		disp_sprite(24);
	}
	if(walkb <= toFIXED(25.0) & walkb >= toFIXED(22.0))
	{
		//disp_sprite(25);
		disp_sprite(23);
	}
	if(walkb <= toFIXED(29.0) & walkb >= toFIXED(26.0))
	{
		//disp_sprite(26);
		disp_sprite(23);
	}
	if(walkb <= toFIXED(33.0) & walkb >= toFIXED(30.0))
	{
		//disp_sprite(27);
		disp_sprite(23);
	}
	if(walkb <= toFIXED(37.0) & walkb >= toFIXED(34.0))
	{
		//disp_sprite(28);
		disp_sprite(23);
	}	
	if(walkb == toFIXED(37))
	{
		walkb = 0;
	}
}
/*----------------------------------------------------------------------*/
void UpdateSpritePosition()
{
	stat[1][0] = stat[0][0];	stat[1][1] = stat[0][1];
	stat[2][0] = stat[0][0];	stat[2][1] = stat[0][1];
	stat[3][0] = stat[0][0];	stat[3][1] = stat[0][1];
	stat[4][0] = stat[0][0];	stat[4][1] = stat[0][1];
	stat[5][0] = stat[0][0];	stat[5][1] = stat[0][1];
	stat[6][0] = stat[0][0];	stat[6][1] = stat[0][1];
	stat[7][0] = stat[0][0];	stat[7][1] = stat[0][1];
	stat[8][0] = stat[0][0];	stat[8][1] = stat[0][1];
	stat[9][0] = stat[0][0];	stat[9][1] = stat[0][1];
	stat[10][0] = stat[0][0];	stat[10][1] = stat[0][1];
	stat[11][0] = stat[0][0];	stat[11][1] = stat[0][1];
	stat[12][0] = stat[0][0];	stat[12][1] = stat[0][1];
	stat[13][0] = stat[0][0];	stat[13][1] = stat[0][1];
	stat[14][0] = stat[0][0];	stat[14][1] = stat[0][1];
	stat[15][0] = stat[0][0];	stat[15][1] = stat[0][1];
	stat[16][0] = stat[0][0];	stat[16][1] = stat[0][1];
	stat[17][0] = stat[0][0];	stat[17][1] = stat[0][1];
	stat[18][0] = stat[0][0];	stat[18][1] = stat[0][1];
	stat[19][0] = stat[0][0];	stat[19][1] = stat[0][1];
	stat[20][0] = stat[0][0];	stat[20][1] = stat[0][1];
	stat[21][0] = stat[0][0];	stat[21][1] = stat[0][1];
	stat[22][0] = stat[0][0];	stat[22][1] = stat[0][1];
	stat[23][0] = stat[0][0];	stat[23][1] = stat[0][1];
	stat[24][0] = stat[0][0];	stat[24][1] = stat[0][1];
	//stat[25][0] = stat[0][0];	stat[25][1] = stat[0][1];
	//stat[26][0] = stat[0][0];	stat[26][1] = stat[0][1];
	//stat[27][0] = stat[0][0];	stat[27][1] = stat[0][1];
	//stat[28][0] = stat[0][0];	stat[28][1] = stat[0][1];
}
/*----------------------------------------------------------------------*/
